Node Utility
===============

The Node Utility provides an expressive way to collect, create, and manipulate
DOM nodes. Each Node instance represents an underlying DOM node, and each
NodeList represents a collection of DOM nodes.

The following modules are available:

  * `node`: Rollup of `node-base`, `node-event-delegate`, `node-pluginhost`,
    `node-screen`, and `node-style`.
  * `node-base`: Provides the basic support for querying, creating, and using
    DOM nodes.
  * `node-event-delegate`: Adds support for delegating Node events.
  * `node-pluginhost`: Enables Node for plugins. 
  * `node-screen`: Provides methods for positioning elements, measuring the
    document and viewport, and working with regions. 
  * `node-style`: Adds setStyle()/getStyle() and getComputedStyle() methods
    for working with style properties.
